-- HudMap have some trouble with OnCombatStart and OnCombatEnd So...... I need to create a frame and Update it


local encounters = HudMap:GetModule("Encounters")
local HudMap = HudMap
local L = LibStub("AceLocale-3.0"):GetLocale("HudMap")
local free = HudMap.free
local PosData = {
	interval = 6,
	start = 29.5,
	centerOfcircleX = 709.8,
	centerOfcircleY = 500.4
}

local function register(e)	
	encounters:RegisterEncounterMarker(e)
	return e
end

local function markerUpdate(self)

		if (not self.mod:Option("windEnabled")) or encounters.GuidToMobID[UnitGUID("boss1") or "0"] ~= self.mod.startEncounterIDs then   -- Are you in encounter with Alakir?
			for i=1, 7 do
				self[i].texture:Hide()             --sucks ,why self[i]:Hide() doesn't work?
				self[i].text:Hide()
			end
			return
		end

		HudMap:Toggle(true)  -- db.autohide = true and HudMap.activeobjects > 0 , Why is HudMap still hidden.....

		local xp,yp = HudMap:GetUnitPosition("player")
		local x, y = xp - PosData.centerOfcircleX, yp - PosData.centerOfcircleY
		local sinp,cosp = y/((x^2+y^2)^0.5) , x/((x^2+y^2)^0.5)
		
		if self[1] and self[1].freed then
			for i=1,7 do					-- HudMap cache the Freed Markers and reuse them.... When the event "ZONE_CHANGED" triggers, self[i] will
				self[i] = nil               -- be freed, and later when you create another one, it will make something like self[1] == self[4].....
			end                             -- I'm sucked by this bug for a whole day!!
		end                                            
		
		for i=1, 7 do
			if (not self[i]) or (self[i] and self[i].freed) then
				HudMap.canvas:Show()        -- HudMap.currentZone will sometimes be 0.......And PlaceRangeMaker method won't work.......
				HudMap:UpdateZoneData()     
				self[i] = register(HudMap:PlaceRangeMarker("highlight", PosData.centerOfcircleX+(PosData.start+PosData.interval*(i-1))*cosp, PosData.centerOfcircleY+(PosData.start+PosData.interval*(i-1))*sinp, PosData.interval/2, nil, self.mod:Option("windColor")):SetLabel(i.."("..(8-i)..")"))
			else
				self[i]:Stick(nil,PosData.centerOfcircleX+(PosData.start+PosData.interval*(i-1))*cosp, PosData.centerOfcircleY+(PosData.start+PosData.interval*(i-1))*sinp)
			end
				
				
			if self[i]:Distance(HudMap:GetUnitPosition("player")) < PosData.interval * 1.5 then
				self[i].texture:Show()
				self[i].text:Show()
			else
				self[i].texture:Hide()
				self[i].text:Hide()
			end
		end

end


local alakir = {
	name = L["Alakir"],
	cache = CreateFrame("frame"),
	startEncounterIDs = 46753,
	endEncounterIDs = 46753,
	Start = function(self)                    -- Combat Log between 180 seconds will trigger this function........
		if self:Option("windEnabled") then 	  --  What if your combat only lasts 30 seconds??? This occurs very much often So i have to make OnUpdate scripts
			self.cache.mod = self
			local xp,yp = HudMap:GetUnitPosition("player")
			local x,y = xp-PosData.centerOfcircleX,yp-PosData.centerOfcircleY
			local sinp,cosp = y/((x^2+y^2)^0.5) , x/((x^2+y^2)^0.5)
			local r, b, g, a = self:Option("windColor")
			
			for i=1, 7 do
				if (not self.cache[i]) or self.cache[i].freed then
					self.cache[i] = register(HudMap:PlaceRangeMarker("highlight", PosData.centerOfcircleX+(PosData.start+PosData.interval*(i-1))*cosp, PosData.centerOfcircleY+(PosData.start+PosData.interval*(i-1))*sinp, PosData.interval/2, nil, r, b, g, a):SetLabel(i.."("..(8-i)..")"))
				end
			end
			
			self.cache:SetScript("OnUpdate",markerUpdate)
			self.cache:Show()
		end
	end,
	Win = function(self)                              -- this function only trigers when you kill boss, What if when you're killed by boss and wipe?
		for i=1, 7 do                                 -- So i have to Add some codes in OnUpdate scripts
			self.cache[i] = free(self.cache[i])       -- Why so many bugs! damn it !
		end
		self.cache:Hide()
	end,
	---[[
	options = {
		wind = L["Wind Wall Position"],
	},
	defaults = {
		WindWall = true,
		windColor = {r = 1, g = 0, b = 0, a = 0.5}
	},
	--]]
	-- Wind Wall
	CHAT_MSG_MONSTER_YELL = function(self,msg)
		if msg == L.phase3 then
			for i=1, 7 do
				self.cache[i] = free(self.cache[i])
			end
			self.cache:Hide()
		end
	end,
}

encounters:RegisterModule(L["Thrones of Four Wind"], alakir)